# The git repo is a hodgepodge.
# Most recent tag is 1.5.4, but that is outdated
# CMakeLists.txt's project() line contains 1.5.5, but this is outdated too
# The SPIR-V version is 1.6.1 (include/spirv/unified1/spirv.core.grammar.json)
# They add "SDK" tags that reflect the Vulkan version (1.3),
# and the independently increasing toolchain release number (216).

%define sdkver  1.3.246.1

Name:           spirv-headers
Version:        1.6.1+%{sdkver}
Release:        1%{?dist}
Summary:        Header files from the SPIR-V registry

License:        MIT
URL:            https://github.com/KhronosGroup/SPIRV-Headers/
Source0:        %url/archive/sdk-%{sdkver}.tar.gz#/SPIRV-Headers-sdk-%{sdkver}.tar.gz


BuildArch:      noarch

BuildRequires:  cmake
BuildRequires:  gcc-c++
%if 0%{?rhel} && 0%{?rhel} > 7
BuildRequires:  pkgconf-pkg-config
%endif

%description
%{summary}

This includes:

* Header files for various languages.
* JSON files describing the grammar for the SPIR-V core instruction
  set, and for the GLSL.std.450 extended instruction set.
* The XML registry file

%package        devel
Summary:        Development files for %{name}

%description    devel
%{summary}

This includes:

* Header files for various languages.
* JSON files describing the grammar for the SPIR-V core instruction
  set, and for the GLSL.std.450 extended instruction set.
* The XML registry file.

%prep
%autosetup -n SPIRV-Headers-sdk-%{sdkver}

%build
%cmake
%cmake_build

%install
%cmake_install

%files devel
%license LICENSE
%doc README.md
%{_includedir}/spirv/
%{_datadir}/cmake/*
%{_datadir}/pkgconfig/SPIRV-Headers.pc

%changelog
* Mon May 15 2023 Jean-Marc Liger <ligenix@iscp.fr> - 1.6.1+1.3.246.1-1
- Update to 1.6.1 + sdk 1.3.246.1 (1feaf44)
  * Added SPRIV_INTEL_argument_interfaces, RegisterMapInterfaceINTEL,
    SPV_QCOM_image_processing
  * Added support for SPV_INTEL_fpga_latency_control extension
  * Headers support for SPV_INTEL_bfloat16_conversion

* Sat Feb 18 2023 Jean-Marc Liger <ligenix@iscp.fr> - 1.6.1+1.3.239.0-1
- Update to 1.6.1 + sdk 1.3.239.0 (d13b522)
  * Add SPV_INTEL_fpga_invocation_pipelining_attributes,
    SPV_INTEL_fpga_dsp_control, SPV_INTEL_runtime_aligned
  * Add headers for SPV_NV_shader_invocation_reorder
  * Update ClspvReflection non-semantic instruction set
  * Add support for StreamingInterfaceINTEL in headers
  * C++ headers: Define & and ~ bitwise operators for mask enums
  * Add operator^
  * Make operands to Kernel added in v5 optional
- Rebuild for COPR EL7, EL8 and EL9

* Fri Nov 11 2022 Jean-Marc Liger <ligenix@iscp.fr> - 1.6.1+1.3.231.1-1
- Update to 1.6.1 + sdk 1.3.231.1 (85a1ed2)
  * Implement headers definitions for SPV_EXT_mesh_shader
  * Add definitions for SPV_ARM_core_builtins
  * Something with VK_EXT_opacity_micromap
  * Add support for texel buffers to clspv non-semantic
    instruction set
- Rebuild for COPR EL7, EL8 and EL9

* Wed Sep 21 2022 Jean-Marc Liger <ligenix@iscp.fr> - 1.6.1+1.3.224.1-1
- Update to 1.6.1 + sdk 1.3.224.1 (b2a156e)
  * Updated clspv reflection non-semantic instruction set
  * Resolved missing update of spirv.bf
- Rebuild for COPR EL7, EL8 and EL9

* Sat Aug 06 2022 Jean-Marc Liger <ligenix@iscp.fr> - 1.6.1+1.3.216.0-1
- Update to 1.6.1 + sdk 1.3.216.0 (b2a156e)
  * Add a SourceLanguage for SYCL
  * Add NamedBarrierCountINTEL execution mode
  * Add SPV_KHR_subgroup_rotate, SPV_KHR_ray_cull_mask,
    SPV_AMD_shader_early_and_late_fragment_tests
- Rebuild for COPR EL7, EL8 and EL9

* Tue Apr 26 2022 Jean-Marc Liger <ligenix@iscp.fr> - 1.6.1+1.3.211.0-1
- Update to 1.6.1 + sdk 1.3.211.0 (4995a2f)
  * Implement SPV_KHR_uniform_group_instructions extension
  * Update SPIR-V headers for SPV_INTEL_split_barrier
  * Implement SPV_INTEL_memory_access_aliasing extension
- Rebuild for COPR EL7 and EL8

* Wed Feb 02 2022 Jean-Marc Liger <ligenix@iscp.fr> - 1.6.g6-1
- Update to snapshot 1.6.g6 (b42ba6d) for 1.3.204 SDK
- Rebuild for COPR EL7 and EL8

* Tue Feb 01 2022 Jean-Marc Liger <ligenix@iscp.fr> - 1.5.4-9.20220115.gitb8047fb
- Update to spirv headers for 1.3.204 sdk
- Rebuild for COPR EL7 and EL8

* Mon Nov 29 2021 Jean-Marc Liger <ligenix@iscp.fr> - 1.5.4-8.20211110.git814e728
- Update to spirv headers for 1.2.200 sdk
- Rebuild for COPR EL7 and EL8

* Mon Oct 18 2021 Jean-Marc Liger <ligenix@iscp.fr> - 1.5.4-8.20211008.git19e8350
- Update to spirv headers for 1.2.196 sdk
- Rebuild for COPR EL7 and EL8

* Tue Sep 07 2021 Dave Airlie <airlied@redhat.com> - 1.5.4-7.20210728.git449bc98
- Update to spirv headers for 1.2.189 sdk

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.5.4-6.20210617.git07f259e
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Wed Jul 07 2021 Dave Airlie <airlied@redhat.com> - 1.5.4-5.20210617.git07f259
- Update to spirv headers for 1.2.182 sdk

* Tue May 18 2021 Dave Airlie <airlied@redhat.com> - 1.5.4-4.20210415.gitdafead1
- Update to spirv headers for 1.2.176 sdk

* Thu Jan 28 2021 Dave Airlie <airlied@redhat.com> - 1.5.4-3.20201128.gitf027d53
- Update to spirv headers for 1.2.162 sdk

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.5.4-2.20201024.git7845730
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Mon Nov 02 2020 Dave Airlie <airlied@redhat.com> - 1.5.4-1
- Update to latest spirv headers

* Tue Aug 04 2020 Dave Airlie <airlied@redhat.com> - 1.5.1-5.20200803.git3fdabd0
- Update to latest spirv headers

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.5.1-4.20200414.git2ad0492
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Apr 22 2020 Dave Airlie <airlied@redhat.com> - 1.5.1-3
- Update to latest spirv headers

* Wed Jan 29 2020 Dave Airlie <airlied@redhat.com> - 1.5.1-2
- Update to latest spirv headers

* Tue Nov 12 2019 Dave Airlie <airlied@redhat.com> - 1.5.1-1
- Latest git snapshot building vulkan

* Thu Aug 01 2019 Dave Airlie <airlied@redhat.com> - 1.4.2-0.1
- Latest git snapshot for building vulkan.

* Fri Jul 26 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Mon Jun 10 2019 Robert-André Mauchin <zebob.m@gmail.com> - 1.4.1-1
- Release 1.4.1

* Thu Mar 07 2019 Dave Airlie <airlied@redhat.com> - 1.2-0.12.20190307.git03a0815
- Update to latest version

* Mon Feb 04 2019 Dave Airlie <airlied@redhat.com> - 1.2-0.11.20190125.git8bea0a2
- Update to latest version

* Sun Feb 03 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.2-0.10.20180703.gitff684ff
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Sat Oct 20 2018 Leigh Scott <leigh123linux@googlemail.com> - 1.2-0.9.20180703.gitff684ff
- Revert last commit

* Sat Oct 20 2018 Leigh Scott <leigh123linux@googlemail.com> - 1.2-0.8.20180919.gitd5b2e12
- Update for SPIRV-Tools-2018.5

* Mon Jul 23 2018 Leigh Scott <leigh123linux@googlemail.com> - 1.2-0.7.20180703.gitff684ff
- Update for SPIRV-Tools-2018.4

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.2-0.6.20180405.git12f8de9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Tue Apr 24 2018 Leigh Scott <leigh123linux@googlemail.com> - 1.2-0.5.20180405.git12f8de9
- Update for vulkan 1.0.73.0

* Fri Feb 09 2018 Leigh Scott <leigh123linux@googlemail.com> - 1.2-0.4.20180201.gitce30920
- Update for vulkan 1.0.68.0

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.2-0.3.20171015.git0610978
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Mon Jan 22 2018 Leigh Scott <leigh123linux@googlemail.com> - 1.2-0.2.20171015.git0610978
- fix rpmlint error

* Thu Jul 13 2017 Leigh Scott <leigh123linux@googlemail.com> - 1.2-0.1.20171015.git0610978
- First build
